Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4NuclearLevelManager.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4NuclearLevelManager.cc	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4NuclearLevelManager.cc	(revision 1340)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-//
+// $Id: G4NuclearLevelManager.cc,v 1.13 2010/10/10 23:01:39 mkelsey Exp $
 // -------------------------------------------------------------------
 //      GEANT 4 class file 
@@ -42,5 +42,6 @@
 //              reading from experimental data. 
 //        02 May 2003,   Vladimir Ivanchenko remove rublic copy constructor
-//      
+//        06 Oct 2010, M. Kelsey -- Use object storage, not pointers, drop
+//		public access to list, simplify list construction
 // -------------------------------------------------------------------
 
@@ -63,87 +64,57 @@
 
 G4NuclearLevelManager::G4NuclearLevelManager(const G4int Z, const G4int A, const G4String& filename) :
-    _nucleusA(A), _nucleusZ(Z), _fileName(filename)
+    _nucleusA(A), _nucleusZ(Z), _fileName(filename), _validity(false), 
+    _levels(0), _levelEnergy(0), _gammaEnergy(0), _probability(0)
 { 
     if (A <= 0 || Z <= 0 || Z > A )
 	throw G4HadronicException(__FILE__, __LINE__, "==== G4NuclearLevelManager ==== (Z,A) <0, or Z>A");
 
-    _levels = 0;
-
     MakeLevels();
 }
 
 G4NuclearLevelManager::~G4NuclearLevelManager()
-{ 
-  if ( _levels ) {
-    if (_levels->size()>0) 
-      {
-	std::for_each(_levels->begin(), _levels->end(), DeleteLevel());
-	_levels->clear();
-      }
-    delete _levels;
-    _levels = 0;
-  }
+{
+  ClearLevels();
 }
 
 void G4NuclearLevelManager::SetNucleus(const G4int Z, const G4int A, const G4String& filename)
 {
-    if (_nucleusZ != Z || _nucleusA != A)
+  if (A <= 0 || Z <= 0 || Z > A )
+    throw G4HadronicException(__FILE__, __LINE__, "==== G4NuclearLevelManager ==== (Z,A) <0, or Z>A");
+
+  if (_nucleusZ != Z || _nucleusA != A)
     {
-	_nucleusA = A;
-	_nucleusZ = Z;
-	_fileName = filename;
-	MakeLevels();
+      _nucleusA = A;
+      _nucleusZ = Z;
+      _fileName = filename;
+      MakeLevels();
     }
-    
-}
-
-G4bool G4NuclearLevelManager::IsValid() const
-{
-    return _validity;
-}
-
-
-G4int G4NuclearLevelManager::NumberOfLevels() const
-{
-    G4int n = 0;
-    if (_levels != 0) n = _levels->size();
-    return n;
-}
-
-
-const G4PtrLevelVector* G4NuclearLevelManager::GetLevels() const
-{
-    return _levels;
-}
-
-
-const G4NuclearLevel* G4NuclearLevelManager::
-NearestLevel(const G4double energy, const G4double eDiffMax) const
-{
-    G4int iNear = -1;
-  
-    G4double diff = 9999. * GeV;
-    if (_levels != 0)
+}
+
+const G4NuclearLevel* G4NuclearLevelManager::GetLevel(int i) const {
+  return (i>=0 && i<NumberOfLevels()) ? (*_levels)[i] : 0;
+}
+
+
+const G4NuclearLevel* 
+G4NuclearLevelManager::NearestLevel(const G4double energy, 
+				    const G4double eDiffMax) const {
+  if (NumberOfLevels() <= 0) return 0;
+
+  G4int iNear = -1;
+  
+  G4double diff = 9999. * GeV;
+  for (unsigned int i=0; i<_levels->size(); i++)
     {
-	unsigned int i = 0;
-	for (i=0; i<_levels->size(); i++)
-	{
-	    G4double e = _levels->operator[](i)->Energy();
-	    G4double eDiff = std::abs(e - energy);
-	    if (eDiff < diff && eDiff <= eDiffMax)
-	    { 
-		diff = eDiff; 
-		iNear = i;
-	    }
+      G4double e = GetLevel(i)->Energy();
+      G4double eDiff = std::abs(e - energy);
+      if (eDiff < diff && eDiff <= eDiffMax)
+	{ 
+	  diff = eDiff; 
+	  iNear = i;
 	}
     }
-    if (_levels != 0 && iNear >= 0 && iNear < static_cast<G4int>(_levels->size()) )
-    { 
-	return _levels->operator[](iNear); 
-    }
-    else
-    { 
-	return 0; 
-    }
+  
+  return GetLevel(iNear);	// Includes range checking on iNear
 }
 
@@ -151,10 +122,5 @@
 G4double G4NuclearLevelManager::MinLevelEnergy() const
 {
-    G4double eMin = 9999.*GeV;
-    if (_levels != 0)
-    {
-	if (_levels->size() > 0) eMin = _levels->front()->Energy(); 
-    }
-    return eMin;
+  return (NumberOfLevels() > 0) ? _levels->front()->Energy() : 9999.*GeV;
 }
 
@@ -162,10 +128,5 @@
 G4double G4NuclearLevelManager::MaxLevelEnergy() const
 {
-    G4double eMax = 0.;
-    if (_levels != 0)
-    {
-	if (_levels->size() > 0) eMax = _levels->back()->Energy(); 
-    }
-    return eMax;
+  return (NumberOfLevels() > 0) ? _levels->back()->Energy() : 0.*GeV;
 }
 
@@ -173,6 +134,5 @@
 const G4NuclearLevel* G4NuclearLevelManager::HighestLevel() const
 {
-    if (_levels!= 0 && _levels->size() > 0) return _levels->front(); 
-    else return 0; 
+  return (NumberOfLevels() > 0) ? _levels->front() : 0;
 }
 
@@ -180,15 +140,20 @@
 const G4NuclearLevel* G4NuclearLevelManager::LowestLevel() const
 {
-    if (_levels != 0 && _levels->size() > 0) return _levels->back();
-    else return 0;
-}
-
-
-G4bool G4NuclearLevelManager::Read(std::ifstream& dataFile)
-{
-  const G4double minProbability = 1e-8;
-  
+  return (NumberOfLevels() > 0) ? _levels->back() : 0;
+}
+
+
+G4bool G4NuclearLevelManager::Read(std::ifstream& dataFile) {
+  G4bool goodRead = ReadDataLine(dataFile);
+  
+  if (goodRead) ProcessDataLine();
+  return goodRead;
+}
+
+// NOTE:  Standard stream I/O generates a 45 byte std::string per item!
+
+G4bool G4NuclearLevelManager::ReadDataLine(std::ifstream& dataFile) {
+  /***** DO NOT USE REGULAR STREAM I/O
   G4bool result = true;
-
   if (dataFile >> _levelEnergy)
     {
@@ -197,57 +162,99 @@
 	       >> _l3CC >> _m1CC >> _m2CC >> _m3CC >> _m4CC >> _m5CC
 	       >> _nPlusCC;
-      _levelEnergy *= keV;
-      _gammaEnergy *= keV;
-      _halfLife *= second;
+    }
+  else result = false;
+  *****/
+
+  // Each item will return iostream status
+  return (ReadDataItem(dataFile, _levelEnergy) &&
+	  ReadDataItem(dataFile, _gammaEnergy) &&
+	  ReadDataItem(dataFile, _probability) &&
+	  ReadDataItem(dataFile, _polarity) &&
+	  ReadDataItem(dataFile, _halfLife) &&
+	  ReadDataItem(dataFile, _angularMomentum) &&
+	  ReadDataItem(dataFile, _totalCC) &&
+	  ReadDataItem(dataFile, _kCC) &&
+	  ReadDataItem(dataFile, _l1CC) &&
+	  ReadDataItem(dataFile, _l2CC) &&
+	  ReadDataItem(dataFile, _l3CC) &&
+	  ReadDataItem(dataFile, _m1CC) &&
+	  ReadDataItem(dataFile, _m2CC) &&
+	  ReadDataItem(dataFile, _m3CC) &&
+	  ReadDataItem(dataFile, _m4CC) &&
+	  ReadDataItem(dataFile, _m5CC) &&
+	  ReadDataItem(dataFile, _nPlusCC) );
+}
+
+G4bool 
+G4NuclearLevelManager::ReadDataItem(std::istream& dataFile, G4double& x) {
+  G4bool okay = (dataFile >> buffer);		// Get next token
+  if (okay) x = strtod(buffer, NULL);
+
+  return okay;
+}
+
+
+void G4NuclearLevelManager::ProcessDataLine() {
+  const G4double minProbability = 1e-8;
+  
+  // Assign units for dimensional quantities
+  _levelEnergy *= keV;
+  _gammaEnergy *= keV;
+  _halfLife *= second;
+  
+  // The following adjustment is needed to take care of anomalies in 
+  // data files, where some transitions show up with relative probability
+  // zero
+  if (_probability < minProbability) _probability = minProbability;
+  // the folowwing is to convert icc probability to accumulative ones
+  _l1CC += _kCC;
+  _l2CC += _l1CC;
+  _l3CC += _l2CC;
+  _m1CC += _l3CC;
+  _m2CC += _m1CC;
+  _m3CC += _m2CC;
+  _m4CC += _m3CC;
+  _m5CC += _m4CC;
+  _nPlusCC += _m5CC;
+
+  if (_nPlusCC!=0) {	// Normalize to probabilities
+    _kCC /= _nPlusCC;
+    _l1CC /= _nPlusCC;
+    _l2CC /= _nPlusCC;
+    _l3CC /= _nPlusCC;
+    _m1CC /= _nPlusCC;
+    _m2CC /= _nPlusCC;
+    _m3CC /= _nPlusCC;
+    _m4CC /= _nPlusCC;
+    _m5CC /= _nPlusCC;
+    _nPlusCC /= _nPlusCC;  
+  } else {		// Total was zero, reset to unity
+    _kCC = 1;
+    _l1CC = 1;
+    _l2CC = 1;
+    _l3CC = 1;
+    _m1CC = 1;
+    _m2CC = 1;
+    _m3CC = 1;
+    _m4CC = 1;
+    _m5CC = 1;
+    _nPlusCC = 1;
+  }
 	
-      // The following adjustment is needed to take care of anomalies in 
-      // data files, where some transitions show up with relative probability
-      // zero
-      if (_probability < minProbability) _probability = minProbability;
-      // the folowwing is to convert icc probability to accumulative ones
-      _l1CC += _kCC;
-      _l2CC += _l1CC;
-      _l3CC += _l2CC;
-      _m1CC += _l3CC;
-      _m2CC += _m1CC;
-      _m3CC += _m2CC;
-      _m4CC += _m3CC;
-      _m5CC += _m4CC;
-      _nPlusCC += _m5CC;
-      if(_nPlusCC!=0)
-      {
-        _kCC /= _nPlusCC;
-        _l1CC /= _nPlusCC;
-        _l2CC /= _nPlusCC;
-        _l3CC /= _nPlusCC;
-        _m1CC /= _nPlusCC;
-        _m2CC /= _nPlusCC;
-        _m3CC /= _nPlusCC;
-        _m4CC /= _nPlusCC;
-        _m5CC /= _nPlusCC;
-        _nPlusCC /= _nPlusCC;  
-      }
-      else
-      {
-        _kCC = 1;
-        _l1CC = 1;
-        _l2CC = 1;
-        _l3CC = 1;
-        _m1CC = 1;
-        _m2CC = 1;
-        _m3CC = 1;
-        _m4CC = 1;
-        _m5CC = 1;
-        _nPlusCC = 1;  
-      }
-	
-      // G4cout << "Read " << _levelEnergy << " " << _gammaEnergy << " " << _probability << G4endl;
-    }
-    else
-    {
-	result = false;
-    }
-    
-    return result;
+  // G4cout << "Read " << _levelEnergy << " " << _gammaEnergy << " " << _probability << G4endl;
+}
+
+
+void G4NuclearLevelManager::ClearLevels()
+{
+  _validity = false;
+
+  if (NumberOfLevels() > 0) {
+    std::for_each(_levels->begin(), _levels->end(), DeleteLevel());
+    _levels->clear();
+  }
+
+  delete _levels;
+  _levels = 0;
 }
 
@@ -256,4 +263,6 @@
 {
   _validity = false;
+  if (NumberOfLevels() > 0) ClearLevels();	// Discard existing data
+
   std::ifstream inFile(_fileName, std::ios::in);
   if (! inFile) 
@@ -266,179 +275,66 @@
       return;
     }
-  
-  if (_levels != 0)
-    {
-      if (_levels->size()>0) 
-	{
-	  std::vector<G4NuclearLevel*>::iterator pos;
-	  for(pos=_levels->begin(); pos!=_levels->end(); pos++)
-	    if (*pos) delete *pos;
-	  _levels->clear();
-	}
-      delete _levels;
-    }
-  else 
-    {
-      _validity = true;
-    }
 
   _levels = new G4PtrLevelVector;
-  
-  std::vector<G4double> eLevel;
-  std::vector<G4double> eGamma;
-  std::vector<G4double> wGamma;
-  std::vector<G4double> pGamma; // polarity
-  std::vector<G4double> hLevel; // half life
-  std::vector<G4double> aLevel; // angular momentum
-  std::vector<G4double> kConve; //  internal convertion coefficiencies
-  std::vector<G4double> l1Conve;
-  std::vector<G4double> l2Conve;
-  std::vector<G4double> l3Conve;
-  std::vector<G4double> m1Conve;
-  std::vector<G4double> m2Conve;
-  std::vector<G4double> m3Conve;
-  std::vector<G4double> m4Conve;
-  std::vector<G4double> m5Conve;
-  std::vector<G4double> npConve;
-  std::vector<G4double> toConve;
+
+  // Read individual gamma data and fill levels for this nucleus
  
-	
-  while (Read(inFile))
-    {
-      eLevel.push_back(_levelEnergy);
-      eGamma.push_back(_gammaEnergy);
-      wGamma.push_back(_probability);
-      pGamma.push_back(_polarity);
-      hLevel.push_back(_halfLife);
-      aLevel.push_back(_angularMomentum);
-      kConve.push_back(_kCC);
-      l1Conve.push_back(_l1CC);
-      l2Conve.push_back(_l2CC);
-      l3Conve.push_back(_l3CC);
-      m1Conve.push_back(_m1CC);
-      m2Conve.push_back(_m2CC);
-      m3Conve.push_back(_m3CC);
-      m4Conve.push_back(_m4CC);
-      m5Conve.push_back(_m5CC);
-      npConve.push_back(_nPlusCC);
-      toConve.push_back(_totalCC);
-    }
+  G4NuclearLevel* thisLevel = 0;
+  G4int nData = 0;
+
+  while (Read(inFile)) {
+    thisLevel = UseLevelOrMakeNew(thisLevel);	// May create new pointer
+    AddDataToLevel(thisLevel);
+    nData++;					// For debugging purposes
+  }
+
+  FinishLevel(thisLevel);		// Final  must be completed by hand
   
   // ---- MGP ---- Don't forget to close the file 
   inFile.close();
 	
-  G4int nData = eLevel.size();
-	
   //  G4cout << " ==== MakeLevels ===== " << nData << " data read " << G4endl;
-	
-  G4double thisLevelEnergy = eLevel[0];
-  G4double thisLevelHalfLife = 0.;
-  G4double thisLevelAngMom = 0.;
-  std::vector<G4double> thisLevelEnergies;
-  std::vector<G4double> thisLevelWeights;
-  std::vector<G4double> thisLevelPolarities;
-  std::vector<G4double> thisLevelkCC;
-  std::vector<G4double> thisLevell1CC;
-  std::vector<G4double> thisLevell2CC;
-  std::vector<G4double> thisLevell3CC;
-  std::vector<G4double> thisLevelm1CC;
-  std::vector<G4double> thisLevelm2CC;
-  std::vector<G4double> thisLevelm3CC;
-  std::vector<G4double> thisLevelm4CC;
-  std::vector<G4double> thisLevelm5CC;
-  std::vector<G4double> thisLevelnpCC;
-  std::vector<G4double> thisLeveltoCC;
- 
-  G4double e = -1.;
-  G4int i;
-  for (i=0; i<nData; i++)
-    {
-      e = eLevel[i];
-      if (e != thisLevelEnergy)
-	{
-	  //	  G4cout << "Making a new level... " << e << " " 
-	  //		 << thisLevelEnergies.entries() << " " 
-	  //		 << thisLevelWeights.entries() << G4endl;
-	  
-	  G4NuclearLevel* newLevel = new G4NuclearLevel(thisLevelEnergy,
-							thisLevelHalfLife,
-							thisLevelAngMom,
-							thisLevelEnergies,
-							thisLevelWeights,
-							thisLevelPolarities,
-							thisLevelkCC,
-							thisLevell1CC,
-							thisLevell2CC,
-							thisLevell3CC,
-							thisLevelm1CC,
-							thisLevelm2CC,
-							thisLevelm3CC,
-							thisLevelm4CC,
-							thisLevelm5CC,
-							thisLevelnpCC,
-							thisLeveltoCC );
-							
-	  _levels->push_back(newLevel);
-	  // Reset data vectors
-	  thisLevelEnergies.clear();
-	  thisLevelWeights.clear();
-	  thisLevelPolarities.clear();
-	  thisLevelkCC.clear();
-	  thisLevell1CC.clear();
-	  thisLevell2CC.clear();
-	  thisLevell3CC.clear();
-	  thisLevelm1CC.clear();
-	  thisLevelm2CC.clear();
-	  thisLevelm3CC.clear();
-	  thisLevelm4CC.clear();
-	  thisLevelm5CC.clear();
-	  thisLevelnpCC.clear();
-	  thisLeveltoCC.clear();
-	  thisLevelEnergy = e;
-	}
-      // Append current data
-      thisLevelEnergies.push_back(eGamma[i]);
-      thisLevelWeights.push_back(wGamma[i]);
-      thisLevelPolarities.push_back(pGamma[i]);
-      thisLevelkCC.push_back(kConve[i]);
-      thisLevell1CC.push_back(l1Conve[i]);
-      thisLevell2CC.push_back(l2Conve[i]);
-      thisLevell3CC.push_back(l3Conve[i]);
-      thisLevelm1CC.push_back(m1Conve[i]);
-      thisLevelm2CC.push_back(m2Conve[i]);
-      thisLevelm3CC.push_back(m3Conve[i]);
-      thisLevelm4CC.push_back(m4Conve[i]);
-      thisLevelm5CC.push_back(m5Conve[i]);
-      thisLevelnpCC.push_back(npConve[i]);
-      thisLeveltoCC.push_back(toConve[i]);
-      thisLevelHalfLife = hLevel[i];
-      thisLevelAngMom = aLevel[i];
-    }
-    // Make last level
-    if (e > 0.)
-      {
-	G4NuclearLevel* newLevel = new G4NuclearLevel(e,thisLevelHalfLife,
-						      thisLevelAngMom,
-						      thisLevelEnergies,
-						      thisLevelWeights,
-						      thisLevelPolarities,
-						      thisLevelkCC,
-						      thisLevell1CC,
-						      thisLevell2CC,
-						      thisLevell3CC,
-						      thisLevelm1CC,
-						      thisLevelm2CC,
-						      thisLevelm3CC,
-						      thisLevelm4CC,
-						      thisLevelm5CC,
-						      thisLevelnpCC,
-						      thisLeveltoCC );
-
-	_levels->push_back(newLevel);
-    }
-
-	G4PtrSort<G4NuclearLevel>(_levels);
-
-    return;
+
+  G4PtrSort<G4NuclearLevel>(_levels);
+  
+  _validity = true;
+  
+  return;
+}
+
+G4NuclearLevel* 
+G4NuclearLevelManager::UseLevelOrMakeNew(G4NuclearLevel* level) {
+  if (level && _levelEnergy == level->Energy()) return level;	// No change
+
+  if (level) FinishLevel(level);	// Save what we have up to now
+
+  //  G4cout << "Making a new level... " << _levelEnergy << G4endl;
+  return new G4NuclearLevel(_levelEnergy, _halfLife, _angularMomentum);
+}
+
+void G4NuclearLevelManager::AddDataToLevel(G4NuclearLevel* level) {
+  if (!level) return;		// Sanity check
+
+  level->_energies.push_back(_gammaEnergy);
+  level->_weights.push_back(_probability);
+  level->_polarities.push_back(_polarity);
+  level->_kCC.push_back(_kCC);
+  level->_l1CC.push_back(_l1CC);
+  level->_l2CC.push_back(_l2CC);
+  level->_l3CC.push_back(_l3CC);
+  level->_m1CC.push_back(_m1CC);
+  level->_m2CC.push_back(_m2CC);
+  level->_m3CC.push_back(_m3CC);
+  level->_m4CC.push_back(_m4CC);
+  level->_m5CC.push_back(_m5CC);
+  level->_nPlusCC.push_back(_nPlusCC);
+  level->_totalCC.push_back(_totalCC);
+}
+
+void G4NuclearLevelManager::FinishLevel(G4NuclearLevel* level) {
+  if (!level || !_levels) return;		// Sanity check
+
+  level->Finalize();
+  _levels->push_back(level);
 }
 
@@ -446,16 +342,14 @@
 void G4NuclearLevelManager::PrintAll()
 {
-    G4int nLevels = 0;
-    if (_levels != 0) nLevels = _levels->size();
+  G4int nLevels = NumberOfLevels();
     
-    G4cout << " ==== G4NuclearLevelManager ==== (" << _nucleusZ << ", " << _nucleusA
-	   << ") has " << nLevels << " levels" << G4endl
-	   << "Highest level is at energy " << MaxLevelEnergy() << " MeV "
-	   << G4endl << "Lowest level is at energy " << MinLevelEnergy()
-	   << " MeV " << G4endl;
+  G4cout << " ==== G4NuclearLevelManager ==== (" << _nucleusZ << ", " << _nucleusA
+	 << ") has " << nLevels << " levels" << G4endl
+	 << "Highest level is at energy " << MaxLevelEnergy() << " MeV "
+	 << G4endl << "Lowest level is at energy " << MinLevelEnergy()
+	 << " MeV " << G4endl;
     
-    G4int i = 0;
-    for (i=0; i<nLevels; i++)
-    { _levels->operator[](i)->PrintAll(); }
+  for (G4int i=0; i<nLevels; i++)
+    GetLevel(i)->PrintAll();
 }
 
@@ -484,4 +378,5 @@
     _fileName = right._fileName;
     _validity = right._validity;
+
     if (right._levels != 0)   
       {
@@ -491,5 +386,5 @@
 	for (i=0; i<n; i++)
 	  {
-	    _levels->push_back(new G4NuclearLevel(*(right._levels->operator[](i))));
+	    _levels->push_back(new G4NuclearLevel(*(right.GetLevel(i))));
 	  }
 	
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4NuclearLevelStore.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4NuclearLevelStore.cc	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4NuclearLevelStore.cc	(revision 1340)
@@ -24,11 +24,10 @@
 // ********************************************************************
 //
+// $Id: G4NuclearLevelStore.cc,v 1.4 2010/10/07 07:50:13 mkelsey Exp $
 //
+// 20101006  M. Kelsey -- Drop static data members.
 
 #include "G4NuclearLevelStore.hh"
 #include <sstream>
-
-std::map<G4String,G4NuclearLevelManager*> G4NuclearLevelStore::theManagers;
-G4String G4NuclearLevelStore::dirName("");
 
 G4NuclearLevelStore* G4NuclearLevelStore::GetInstance()
@@ -56,13 +55,11 @@
 G4NuclearLevelStore::~G4NuclearLevelStore()
 {
-    std::map<G4String,G4NuclearLevelManager*>::iterator i;
+    ManagersMap::iterator i;
     for (i = theManagers.begin(); i != theManagers.end(); ++i)
-    {
-	if ( (*i).second ) delete (*i).second;
-    }
+      delete i->second;
 }
 
-G4String G4NuclearLevelStore::GenerateKey(const G4int Z, const G4int A)
-{
+G4String 
+G4NuclearLevelStore::GenerateFilename(const G4int Z, const G4int A) const {
     std::ostringstream streamName; 
     streamName << 'z' << Z << ".a" << A;
@@ -72,6 +69,6 @@
 
 
-G4NuclearLevelManager* G4NuclearLevelStore::GetManager(const G4int Z, const G4int A)
-{
+G4NuclearLevelManager* 
+G4NuclearLevelStore::GetManager(const G4int Z, const G4int A) {
     G4NuclearLevelManager * result = 0; 
     if (A < 1 || Z < 1 || A < Z)
@@ -81,15 +78,16 @@
 	return result;
     }
+
     // Generate the key = filename
-    G4String key(this->GenerateKey(Z,A));
+    G4int key = GenerateKey(Z,A);
     
     // Check if already exists that key
-    std::map<G4String,G4NuclearLevelManager*>::iterator idx = theManagers.find(key);
+    ManagersMap::iterator idx = theManagers.find(key);
     // If doesn't exists then create it
     if ( idx == theManagers.end() )
     {
-	result = new G4NuclearLevelManager();
-	result->SetNucleus(Z,A,dirName + key);
-	theManagers.insert(std::make_pair(key,result));
+        G4String file = GenerateFilename(Z,A);
+        result = new G4NuclearLevelManager(Z,A,dirName + file);
+        theManagers.insert(std::make_pair(key,result));
     }
     // But if it exists...
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4PhotonEvaporation.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4PhotonEvaporation.cc	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4PhotonEvaporation.cc	(revision 1340)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PhotonEvaporation.cc,v 1.13 2010/05/17 11:47:43 flei Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4VGammaDeexcitation.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4VGammaDeexcitation.cc	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4VGammaDeexcitation.cc	(revision 1340)
@@ -25,5 +25,5 @@
 //
 // $Id: G4VGammaDeexcitation.cc,v 1.18 2010/06/25 09:46:13 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4VPhotonEvaporation.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4VPhotonEvaporation.cc	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4VPhotonEvaporation.cc	(revision 1340)
@@ -41,5 +41,5 @@
 //
 // $Id: G4VPhotonEvaporation.cc,v 1.3 2010/04/25 18:43:21 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 
 
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4AlphaCoulombBarrier.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4AlphaCoulombBarrier.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4AlphaCoulombBarrier.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4AlphaCoulombBarrier.hh,v 1.4 2008/09/19 13:32:54 ahoward Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronGilbertPairingCorrections.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronGilbertPairingCorrections.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronGilbertPairingCorrections.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CameronGilbertPairingCorrections.hh,v 1.5 2009/03/04 11:05:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronGilbertShellCorrections.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronGilbertShellCorrections.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronGilbertShellCorrections.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CameronGilbertShellCorrections.hh,v 1.5 2009/03/04 11:05:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronShellPlusPairingCorrections.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronShellPlusPairingCorrections.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronShellPlusPairingCorrections.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CameronShellPlusPairingCorrections.hh,v 1.5 2009/03/04 11:05:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronTruranHilfPairingCorrections.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronTruranHilfPairingCorrections.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronTruranHilfPairingCorrections.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CameronTruranHilfPairingCorrections.hh,v 1.5 2009/03/04 11:05:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronTruranHilfShellCorrections.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronTruranHilfShellCorrections.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4CameronTruranHilfShellCorrections.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CameronTruranHilfShellCorrections.hh,v 1.5 2009/03/04 11:05:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4ConstantLevelDensityParameter.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4ConstantLevelDensityParameter.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4ConstantLevelDensityParameter.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ConstantLevelDensityParameter.hh,v 1.5 2009/03/04 11:05:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations (photon evaporation)
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4CookPairingCorrections.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4CookPairingCorrections.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4CookPairingCorrections.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CookPairingCorrections.hh,v 1.5 2009/03/04 11:05:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4CookShellCorrections.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4CookShellCorrections.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4CookShellCorrections.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CookShellCorrections.hh,v 1.5 2009/03/04 11:05:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4CoulombBarrier.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4CoulombBarrier.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4CoulombBarrier.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CoulombBarrier.hh,v 1.6 2009/03/04 11:05:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4DeuteronCoulombBarrier.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4DeuteronCoulombBarrier.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4DeuteronCoulombBarrier.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4DeuteronCoulombBarrier.hh,v 1.5 2009/03/04 11:05:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4EvaporationLevelDensityParameter.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4EvaporationLevelDensityParameter.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4EvaporationLevelDensityParameter.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EvaporationLevelDensityParameter.hh,v 1.5 2009/03/04 11:05:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4He3CoulombBarrier.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4He3CoulombBarrier.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4He3CoulombBarrier.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4He3CoulombBarrier.hh,v 1.5 2009/03/04 11:05:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/util/include/G4NeutronCoulombBarrier.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/util/include/G4NeutronCoulombBarrier.hh	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/util/include/G4NeutronCoulombBarrier.hh	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronCoulombBarrier.hh,v 1.5 2009/03/04 11:05:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // Hadronic Process: Nuclear De-excitations
